#include "StdAfx.h"
#include "CDDBLibraryDefs.h"

namespace CDDBLibrary
{
	static HMODULE CDDBLibraryDLLHandle = NULL;
	bool CDDBLibraryDLLLoaded = false;

	t_CDDB_Create					CDDB_Create = NULL;
	t_CDDB_Free						CDDB_Free = NULL;
	t_CDDB_SetParams				CDDB_SetParams = NULL;
	t_CDDB_GetParams				CDDB_GetParams = NULL;
	t_CDDB_Query					CDDB_Query = NULL;
	t_CDDB_GetTitle				CDDB_GetTitle = NULL;
	t_CDDB_GetTrackCount			CDDB_GetTrackCount = NULL;
	t_CDDB_GetGenre				CDDB_GetGenre = NULL;
	t_CDDB_GetArtist				CDDB_GetArtist = NULL;
	t_CDDB_GetAlbum				CDDB_GetAlbum = NULL;
	t_CDDB_GetYear					CDDB_GetYear = NULL;
	t_CDDB_GetComposer			CDDB_GetComposer = NULL;
	t_CDDB_GetCopyright			CDDB_GetCopyright = NULL;
	t_CDDB_GetURL					CDDB_GetURL = NULL;
	t_CDDB_GetOrigArtist			CDDB_GetOrigArtist = NULL;
	t_CDDB_GetRevision			CDDB_GetRevision = NULL;
	t_CDDB_SubmitClear			CDDB_SubmitClear = NULL;
	t_CDDB_SubmitAddTitle		CDDB_SubmitAddTitle = NULL;
	t_CDDB_SubmitSetGenre		CDDB_SubmitSetGenre = NULL;
	t_CDDB_SubmitSetArtist		CDDB_SubmitSetArtist = NULL;
	t_CDDB_SubmitSetAlbum		CDDB_SubmitSetAlbum = NULL;
	t_CDDB_SubmitSetYear			CDDB_SubmitSetYear = NULL;
	t_CDDB_SubmitSetComposer	CDDB_SubmitSetComposer = NULL;
	t_CDDB_SubmitSetCopyright	CDDB_SubmitSetCopyright = NULL;
	t_CDDB_SubmitSetURL			CDDB_SubmitSetURL = NULL;
	t_CDDB_SubmitSetOrigArtist	CDDB_SubmitSetOrigArtist = NULL;
	t_CDDB_SubmitPerform			CDDB_SubmitPerform = NULL;
	t_CDDB_SubmitSetParams		CDDB_SubmitSetParams = NULL; 
	t_CDDB_SubmitGetParams		CDDB_SubmitGetParams = NULL;
	t_CDDB_SetMultipleMatchCategory	CDDB_SetMultipleMatchCategory = NULL;
	t_CDDB_GetError				CDDB_GetError = NULL;

	/*****************************************************************************************
	* Purpose:		Initialize the CDDB library.
	* Returns:		true on success, false otherwise.
	*****************************************************************************************/
	bool InitCDDBLibrary()
	{	
		CDDBLibraryDLLHandle = ::LoadLibrary(CDDBLibraryDLL);
		if(NULL != CDDBLibraryDLLHandle)
		{
			CDDB_Create						= (t_CDDB_Create)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBCreate);
			CDDB_Free						= (t_CDDB_Free)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBFree);         
			CDDB_SetParams					= (t_CDDB_SetParams)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSetParams);
			CDDB_GetParams					= (t_CDDB_GetParams)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetParams);
			CDDB_Query						= (t_CDDB_Query)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBQuery);
			CDDB_GetTitle					= (t_CDDB_GetTitle)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetTitle);
			CDDB_GetTrackCount			= (t_CDDB_GetTrackCount)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetTrackCount);
			CDDB_GetGenre					= (t_CDDB_GetGenre)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetGenre);
			CDDB_GetArtist					= (t_CDDB_GetArtist)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetArtist);
			CDDB_GetAlbum					= (t_CDDB_GetAlbum)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetAlbum);
			CDDB_GetYear					= (t_CDDB_GetYear)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetYear);
			CDDB_GetComposer				= (t_CDDB_GetComposer)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetComposer);
			CDDB_GetCopyright				= (t_CDDB_GetCopyright)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetCopyright);
			CDDB_GetURL						= (t_CDDB_GetURL)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetURL);
			CDDB_GetOrigArtist			= (t_CDDB_GetOrigArtist)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetOrigArtist);
			CDDB_GetRevision				= (t_CDDB_GetRevision)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetRevision);
			CDDB_SubmitClear				= (t_CDDB_SubmitClear)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitClear);
			CDDB_SubmitAddTitle			= (t_CDDB_SubmitAddTitle)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitAddTitle);
			CDDB_SubmitSetGenre			= (t_CDDB_SubmitSetGenre)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetGenre);
			CDDB_SubmitSetArtist			= (t_CDDB_SubmitSetArtist)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetArtist);
			CDDB_SubmitSetAlbum			= (t_CDDB_SubmitSetAlbum)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetAlbum);
			CDDB_SubmitSetYear			= (t_CDDB_SubmitSetYear)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetYear);
			CDDB_SubmitSetComposer		= (t_CDDB_SubmitSetComposer)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetComposer);
			CDDB_SubmitSetCopyright		= (t_CDDB_SubmitSetCopyright)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetCopyright);
			CDDB_SubmitSetURL				= (t_CDDB_SubmitSetURL)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetURL);
			CDDB_SubmitSetOrigArtist	= (t_CDDB_SubmitSetOrigArtist)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetOrigArtist);
			CDDB_SubmitPerform			= (t_CDDB_SubmitPerform)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitPerform);
			CDDB_SubmitSetParams			= (t_CDDB_SubmitSetParams)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitSetParams);
			CDDB_SubmitGetParams			= (t_CDDB_SubmitGetParams)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSubmitGetParams);
			CDDB_SetMultipleMatchCategory = (t_CDDB_SetMultipleMatchCategory)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBSetMultipleMatchCategory);
			CDDB_GetError					= (t_CDDB_GetError)::GetProcAddress(CDDBLibraryDLLHandle, NAME_CDDBGetError);

			if ( (NULL == CDDB_Create) || (NULL == CDDB_Free) )
			{
				CDDBLibraryDLLLoaded = false;
			} 
			else
			{
				CDDBLibraryDLLLoaded = true;
			}
		} else {
			TRACE( _T("InitCDDBLibrary Failed (%d).\n"), GetLastError() );
		}

		return CDDBLibraryDLLLoaded;
	}

	/*****************************************************************************************
	* Purpose:		Free CDDB library.
	* Returns:		true on success, false otherwise.
	*****************************************************************************************/
	bool FreeCDDBLibrary()
	{
		if (NULL != CDDBLibraryDLLHandle)
		{
			CDDBLibraryDLLLoaded = !::FreeLibrary(CDDBLibraryDLLHandle);
		}
		return !CDDBLibraryDLLLoaded;
	}
}