#pragma once

#define NAME_CDDBCreate              "CDDB_Create"
#define NAME_CDDBFree                "CDDB_Free"
#define NAME_CDDBSetParams           "CDDB_SetParams"
#define NAME_CDDBGetParams           "CDDB_GetParams"
#define NAME_CDDBQuery               "CDDB_Query"
#define NAME_CDDBGetTitle            "CDDB_GetTitle"
#define NAME_CDDBGetTrackCount       "CDDB_GetTrackCount"
#define NAME_CDDBGetGenre            "CDDB_GetGenre"
#define NAME_CDDBGetArtist           "CDDB_GetArtist"
#define NAME_CDDBGetAlbum            "CDDB_GetAlbum"
#define NAME_CDDBGetYear             "CDDB_GetYear"
#define NAME_CDDBGetComposer         "CDDB_GetComposer"
#define NAME_CDDBGetCopyright        "CDDB_GetCopyright"
#define NAME_CDDBGetURL              "CDDB_GetURL"
#define NAME_CDDBGetOrigArtist       "CDDB_GetOrigArtist"
#define NAME_CDDBGetRevision         "CDDB_GetRevision"
#define NAME_CDDBSubmitClear         "CDDB_SubmitClear"
#define NAME_CDDBSubmitAddTitle      "CDDB_SubmitAddTitle"
#define NAME_CDDBSubmitSetGenre      "CDDB_SubmitSetGenre"
#define NAME_CDDBSubmitSetArtist     "CDDB_SubmitSetArtist"
#define NAME_CDDBSubmitSetAlbum      "CDDB_SubmitSetAlbum"
#define NAME_CDDBSubmitSetYear       "CDDB_SubmitSetYear"
#define NAME_CDDBSubmitSetComposer   "CDDB_SubmitSetComposer"
#define NAME_CDDBSubmitSetCopyright  "CDDB_SubmitSetCopyright"
#define NAME_CDDBSubmitSetURL        "CDDB_SubmitSetURL"
#define NAME_CDDBSubmitSetOrigArtist "CDDB_SubmitSetOrigArtist"
#define NAME_CDDBSubmitPerform       "CDDB_SubmitPerform"
#define NAME_CDDBSubmitSetParams     "CDDB_SubmitSetParams"
#define NAME_CDDBSubmitGetParams     "CDDB_SubmitGetParams"
#define NAME_CDDBSetMultipleMatchCategory "CDDB_SetMultipleMatchCategory"
#define NAME_CDDBGetError            "CDDB_GetError"

#define CDDBLibraryDLL _T("CDDBLibrary.dll")

#define CDDB_EMAILADDRESS_SUBMIT			"freedb-submit@freedb.org"
#define CDDB_EMAILADDRESS_TESTSUBMIT	"tstsub@freedb.org"

typedef struct _TCDDB_Params
{
	HWND	Handle;
	LPWSTR	ServerAddr;
	LPWSTR	ServerPort;
	LPWSTR	ProxyAddress;
	LPWSTR	ProxyPort;
	//LPWSTR	ProxyUsername;
	//LPWSTR	ProxyPassword;
	int	TimeOut;
	LPWSTR	UserName;
	LPWSTR	AppURL;
	LPWSTR	AppID;
	LPWSTR	AppVer;
	LPWSTR	ClientComment;
	bool	GetSiteList;
	void*	OnDataExchange;
	void*	OnMatch;
	void*	OnStatusMessage;
	void*	OnDebug;
} *PCDDBParams, TCDDBParams;

typedef struct _TCDDB_SubmitParams
{
	LPWSTR	ServerAddr;
	int	ServerPort;
	LPWSTR	UserName;
	LPWSTR	Password;
	LPWSTR	UserEMail;
	LPWSTR	DestEMail;
	LPWSTR	Agent;
} *PCDDBSubmitParams, TCDDBSubmitParams;

typedef LPVOID(__stdcall *t_CDDB_Create)();
typedef bool(__stdcall *t_CDDB_Free)(LPVOID CDDBLibrary);
typedef bool(__stdcall *t_CDDB_SetParams)(LPVOID CDDBLibrary, TCDDBParams Params);
typedef bool(__stdcall *t_CDDB_GetParams)(LPVOID CDDBLibrary, PCDDBParams Params);
typedef bool(__stdcall *t_CDDB_Query)(LPVOID CDDBLibrary, LPWSTR CDID);
typedef LPWSTR(__stdcall *t_CDDB_GetTitle)(LPVOID CDDBLibrary, DWORD TrackNo);
typedef DWORD(__stdcall *t_CDDB_GetTrackCount)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetGenre)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetArtist)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetAlbum)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetYear)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetComposer)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetCopyright)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetURL)(LPVOID CDDBLibrary);
typedef LPWSTR(__stdcall *t_CDDB_GetOrigArtist)(LPVOID CDDBLibrary);
typedef int(__stdcall *t_CDDB_GetRevision)(LPVOID CDDBLibrary);
typedef bool(__stdcall *t_CDDB_SubmitClear)(LPVOID CDDBLibrary);
typedef bool(__stdcall *t_CDDB_SubmitAddTitle)(LPVOID CDDBLibrary, LPWSTR TrackTitle);
typedef bool(__stdcall *t_CDDB_SubmitSetGenre)(LPVOID CDDBLibrary, LPWSTR Genre);
typedef bool(__stdcall *t_CDDB_SubmitSetArtist)(LPVOID CDDBLibrary, LPWSTR Artist);
typedef bool(__stdcall *t_CDDB_SubmitSetAlbum)(LPVOID CDDBLibrary, LPWSTR Album);
typedef bool(__stdcall *t_CDDB_SubmitSetYear)(LPVOID CDDBLibrary, LPWSTR Year);
typedef bool(__stdcall *t_CDDB_SubmitSetComposer)(LPVOID CDDBLibrary, LPWSTR Composer);
typedef bool(__stdcall *t_CDDB_SubmitSetCopyright)(LPVOID CDDBLibrary, LPWSTR Copyright);
typedef bool(__stdcall *t_CDDB_SubmitSetURL)(LPVOID CDDBLibrary, LPWSTR URL);
typedef bool(__stdcall *t_CDDB_SubmitSetOrigArtist)(LPVOID CDDBLibrary, LPWSTR OrigArtist);
typedef LPWSTR(__stdcall *t_CDDB_SubmitPerform)(LPVOID CDDBLibrary, LPWSTR CDID, int Revision);
typedef bool(__stdcall *t_CDDB_SubmitSetParams)(LPVOID CDDBLibrary, TCDDBSubmitParams Params);
typedef bool(__stdcall *t_CDDB_SubmitGetParams)(LPVOID CDDBLibrary, PCDDBSubmitParams Params);
typedef bool(__stdcall *t_CDDB_SetMultipleMatchCategory)(LPVOID CDDBLibrary, LPWSTR Category);
typedef LPWSTR(__stdcall *t_CDDB_GetError)(LPVOID CDDBLibrary);

namespace CDDBLibrary
{
	bool InitCDDBLibrary();
	bool FreeCDDBLibrary();

	extern t_CDDB_Create						CDDB_Create;
	extern t_CDDB_Free						CDDB_Free;
	extern t_CDDB_SetParams					CDDB_SetParams;
	extern t_CDDB_GetParams					CDDB_GetParams;
	extern t_CDDB_Query						CDDB_Query;
	extern t_CDDB_GetTitle					CDDB_GetTitle;
	extern t_CDDB_GetTrackCount			CDDB_GetTrackCount;
	extern t_CDDB_GetGenre					CDDB_GetGenre;
	extern t_CDDB_GetArtist					CDDB_GetArtist;
	extern t_CDDB_GetAlbum					CDDB_GetAlbum;
	extern t_CDDB_GetYear					CDDB_GetYear;
	extern t_CDDB_GetComposer				CDDB_GetComposer;
	extern t_CDDB_GetCopyright				CDDB_GetCopyright;
	extern t_CDDB_GetURL						CDDB_GetURL;
	extern t_CDDB_GetOrigArtist			CDDB_GetOrigArtist;
	extern t_CDDB_GetRevision				CDDB_GetRevision;
	extern t_CDDB_SubmitClear				CDDB_SubmitClear;
	extern t_CDDB_SubmitAddTitle			CDDB_SubmitAddTitle;
	extern t_CDDB_SubmitSetGenre			CDDB_SubmitSetGenre;
	extern t_CDDB_SubmitSetArtist			CDDB_SubmitSetArtist;
	extern t_CDDB_SubmitSetAlbum			CDDB_SubmitSetAlbum;
	extern t_CDDB_SubmitSetYear			CDDB_SubmitSetYear;
	extern t_CDDB_SubmitSetComposer		CDDB_SubmitSetComposer;
	extern t_CDDB_SubmitSetCopyright		CDDB_SubmitSetCopyright;
	extern t_CDDB_SubmitSetURL				CDDB_SubmitSetURL;
	extern t_CDDB_SubmitSetOrigArtist	CDDB_SubmitSetOrigArtist;
	extern t_CDDB_SubmitPerform			CDDB_SubmitPerform;
	extern t_CDDB_SubmitSetParams			CDDB_SubmitSetParams; 
	extern t_CDDB_SubmitGetParams			CDDB_SubmitGetParams;
	extern t_CDDB_SetMultipleMatchCategory	CDDB_SetMultipleMatchCategory;
	extern t_CDDB_GetError					CDDB_GetError;
};
