//********************************************************************************************************************************
//*                                                                                                                              *
//*     CDDB-FreeDB Library V1.2  3delite 2008-2011                                                                             *
//*     See CDDB-FreeDB Library Readme.txt for details                                                                           *
//*                                                                                                                              *
//* Two licenses are available if you like and use this library:                                                                 *
//* Shareware License: 50 Euros                                                                                                  *
//* Commercial License: 250 Euros                                                                                                *
//*                                                                                                                              *
//*     http://www.3delite.hu/Object%20Pascal%20Developer%20Resources/cddbfreedblibrary.html                                     *
//*                                                                                                                              *
//* If you have any questions or enquiries please mail: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit CDDBLibraryDefs;

interface

uses
    Windows;

    function InitCDDBLibrary: Boolean;
    function FreeCDDBLibrary: Boolean;

const
    CDDBLibraryDLL = 'CDDBLibrary.dll';

const
    CDDB_EMAILADDRESS_SUBMIT     = 'freedb-submit@freedb.org';
    CDDB_EMAILADDRESS_TESTSUBMIT = 'tstsub@freedb.org'; //'test-submit@freedb.org';
    
const
    NAME_CDDBLibraryCreate              = 'CDDB_Create';
    NAME_CDDBLibraryFree                = 'CDDB_Free';
    NAME_CDDBLibrarySetParams           = 'CDDB_SetParams';
    NAME_CDDBLibraryGetParams           = 'CDDB_GetParams';
    NAME_CDDBLibraryQuery               = 'CDDB_Query';
    NAME_CDDBLibraryGetTitle            = 'CDDB_GetTitle';
    NAME_CDDBLibraryGetTrackCount       = 'CDDB_GetTrackCount';
    NAME_CDDBLibraryGetGenre            = 'CDDB_GetGenre';
    NAME_CDDBLibraryGetArtist           = 'CDDB_GetArtist';
    NAME_CDDBLibraryGetAlbum            = 'CDDB_GetAlbum';
    NAME_CDDBLibraryGetYear             = 'CDDB_GetYear';
    NAME_CDDBLibraryGetComposer         = 'CDDB_GetComposer';
    NAME_CDDBLibraryGetCopyright        = 'CDDB_GetCopyright';
    NAME_CDDBLibraryGetURL              = 'CDDB_GetURL';
    NAME_CDDBLibraryGetOriginalArtist   = 'CDDB_GetOrigArtist';
    NAME_CDDBLibraryGetRevision         = 'CDDB_GetRevision';
    NAME_CDDBLibrarySubmitClear         = 'CDDB_SubmitClear';
    NAME_CDDBLibrarySubmitAddTitle      = 'CDDB_SubmitAddTitle';
    NAME_CDDBLibrarySubmitSetGenre      = 'CDDB_SubmitSetGenre';
    NAME_CDDBLibrarySubmitSetArtist     = 'CDDB_SubmitSetArtist';
    NAME_CDDBLibrarySubmitSetAlbum      = 'CDDB_SubmitSetAlbum';
    NAME_CDDBLibrarySubmitSetYear       = 'CDDB_SubmitSetYear';
    NAME_CDDBLibrarySubmitSetComposer   = 'CDDB_SubmitSetComposer';
    NAME_CDDBLibrarySubmitSetCopyright  = 'CDDB_SubmitSetCopyright';
    NAME_CDDBLibrarySubmitSetURL        = 'CDDB_SubmitSetURL';
    NAME_CDDBLibrarySubmitSetOrigArtist = 'CDDB_SubmitSetOrigArtist';
    NAME_CDDBLibrarySubmitPerform       = 'CDDB_SubmitPerform';
    NAME_CDDBLibrarySubmitSetParams     = 'CDDB_SubmitSetParams';
    NAME_CDDBLibrarySubmitGetParams     = 'CDDB_SubmitGetParams';
    NAME_CDDBLibrarySetMultipleMatchCategory = 'CDDB_SetMultipleMatchCategory';
    NAME_CDDBLibraryGetError            = 'CDDB_GetError';

type
    HCDDB = Pointer;

type
    TCDDB_Params = record
        Handle: THandle;
        ServerAddr: PChar;
        ServerPort: PChar;
        ProxyAddress: PChar;
        ProxyPort: PChar;
        TimeOut: Cardinal;
        UserName: PChar;
        AppURL: PChar;
        AppID: PChar;
        AppVer: PChar;
        ClientComment: PChar;
        GetSiteList: Bool;
        OnDataExchange: Pointer;
        OnMatch: Pointer;
        OnStatusMessage: Pointer;
        OnDebug: Pointer;
    end;

type
    TCDDB_SubmitParams = record
        ServerAddr: PChar;
        ServerPort: Integer;
        UserName: PChar;
        Password: PChar;
        UserEMail: PChar;
        DestEMail: PChar;
        Agent: PChar;
    end;

type
    t_CDDB_Create               = function(): HCDDB; stdcall;
    t_CDDB_Free                 = function(CDDB: HCDDB): Bool; stdcall;
    t_CDDB_SetParams            = function(CDDB: HCDDB; Params: TCDDB_Params): Bool; stdcall;
    t_CDDB_GetParams            = function(CDDB: HCDDB; var Params: TCDDB_Params): Bool; stdcall;
    t_CDDB_Query                = function(CDDB: HCDDB; CDID: PChar): Bool; stdcall;
    t_CDDB_GetTitle             = function(CDDB: HCDDB; TrackNo: Cardinal): PChar; stdcall;
    t_CDDB_GetTrackCount        = function(CDDB: HCDDB): Cardinal; stdcall;
    t_CDDB_GetGenre             = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetArtist            = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetAlbum             = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetYear              = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetComposer          = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetCopyright         = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetURL               = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetOriginalArtist    = function(CDDB: HCDDB): PChar; stdcall;
    t_CDDB_GetRevision          = function(CDDB: HCDDB): Integer; stdcall;
    t_CDDB_SubmitClear          = function(CDDB: HCDDB): Bool; stdcall;
    t_CDDB_SubmitAddTitle       = function(CDDB: HCDDB; TrackTitle: PChar): Bool; stdcall;
    t_CDDB_SubmitSetGenre       = function(CDDB: HCDDB; Genre: PChar): Bool; stdcall;
    t_CDDB_SubmitSetArtist      = function(CDDB: HCDDB; Artist: PChar): Bool; stdcall;
    t_CDDB_SubmitSetAlbum       = function(CDDB: HCDDB; Album: PChar): Bool; stdcall;
    t_CDDB_SubmitSetYear        = function(CDDB: HCDDB; Year: PChar): Bool; stdcall;
    t_CDDB_SubmitSetComposer    = function(CDDB: HCDDB; Composer: PChar): Bool; stdcall;
    t_CDDB_SubmitSetCopyright   = function(CDDB: HCDDB; Copyright: PChar): Bool; stdcall;
    t_CDDB_SubmitSetURL         = function(CDDB: HCDDB; URL: PChar): Bool; stdcall;
    t_CDDB_SubmitSetOrigArtist  = function(CDDB: HCDDB; OrigArtist: PChar): Bool; stdcall;
    t_CDDB_SubmitPerform        = function(CDDB: HCDDB; CDID: PChar; Revision: Integer): Bool; stdcall;
    t_CDDB_SubmitSetParams      = function(CDDB: HCDDB; Params: TCDDB_SubmitParams): Bool; stdcall;
    t_CDDB_SubmitGetParams      = function(CDDB: HCDDB; var Params: TCDDB_SubmitParams): Bool; stdcall;
    t_CDDB_SetMultipleMatchCategory = function(CDDB: HCDDB; Category: PWideChar): Bool; stdcall;
    t_CDDB_GetError             = function(CDDB: HCDDB): PWideChar; stdcall;

var
    CDDB_Create: t_CDDB_Create;
    CDDB_Free: t_CDDB_Free;
    CDDB_SetParams: t_CDDB_SetParams;
    CDDB_GetParams: t_CDDB_GetParams;
    CDDB_Query: t_CDDB_Query;
    CDDB_GetTitle: t_CDDB_GetTitle;
    CDDB_GetTrackCount: t_CDDB_GetTrackCount;
    CDDB_GetGenre: t_CDDB_GetGenre;
    CDDB_GetArtist: t_CDDB_GetArtist;
    CDDB_GetAlbum: t_CDDB_GetAlbum;
    CDDB_GetYear: t_CDDB_GetYear;
    CDDB_GetComposer: t_CDDB_GetComposer;
    CDDB_GetCopyright: t_CDDB_GetCopyright;
    CDDB_GetURL: t_CDDB_GetURL;
    CDDB_GetOriginalArtist: t_CDDB_GetOriginalArtist;
    CDDB_GetRevision: t_CDDB_GetRevision;
    CDDB_SubmitClear: t_CDDB_SubmitClear;
    CDDB_SubmitAddTitle: t_CDDB_SubmitAddTitle;
    CDDB_SubmitSetGenre: t_CDDB_SubmitSetGenre;
    CDDB_SubmitSetArtist: t_CDDB_SubmitSetArtist;
    CDDB_SubmitSetAlbum: t_CDDB_SubmitSetAlbum;
    CDDB_SubmitSetYear: t_CDDB_SubmitSetYear;
    CDDB_SubmitSetComposer: t_CDDB_SubmitSetComposer;
    CDDB_SubmitSetCopyright: t_CDDB_SubmitSetCopyright;
    CDDB_SubmitSetURL: t_CDDB_SubmitSetURL;
    CDDB_SubmitSetOrigArtist: t_CDDB_SubmitSetOrigArtist;
    CDDB_SubmitPerform: t_CDDB_SubmitPerform;
    CDDB_SubmitSetParams: t_CDDB_SubmitSetParams;
    CDDB_SubmitGetParams: t_CDDB_SubmitGetParams;
    CDDB_SetMultipleMatchCategory: t_CDDB_SetMultipleMatchCategory;
    CDDB_GetError: t_CDDB_GetError;

var
    CDDBLibraryDLLHandle: THandle = 0;
    CDDBLibraryDLLoaded: Boolean = False;

implementation

Uses
    SysUtils;

function InitCDDBLibrary: Boolean;
begin
    CDDBLibraryDLLHandle := SafeLoadLibrary(PChar(CDDBLibraryDLL));
    Result := CDDBLibraryDLLHandle <> 0;
    if Result then begin
        CDDB_Create             := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryCreate));
        CDDB_Free               := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryFree));
        CDDB_SetParams          := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySetParams));
        CDDB_GetParams          := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetParams));
        CDDB_Query              := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryQuery));
        CDDB_GetTitle           := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetTitle));
        CDDB_GetTrackCount      := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetTrackCount));
        CDDB_GetGenre           := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetGenre));
        CDDB_GetArtist          := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetArtist));
        CDDB_GetAlbum           := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetAlbum));
        CDDB_GetYear            := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetYear));
        CDDB_GetComposer        := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetComposer));
        CDDB_GetCopyright       := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetCopyright));
        CDDB_GetURL             := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetURL));
        CDDB_GetOriginalArtist  := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetOriginalArtist));
        CDDB_GetRevision        := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetRevision));
        CDDB_SubmitClear        := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitClear));
        CDDB_SubmitAddTitle     := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitAddTitle));
        CDDB_SubmitSetGenre     := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetGenre));
        CDDB_SubmitSetArtist    := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetArtist));
        CDDB_SubmitSetAlbum     := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetAlbum));
        CDDB_SubmitSetYear      := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetYear));
        CDDB_SubmitSetComposer  := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetComposer));
        CDDB_SubmitSetCopyright := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetCopyright));
        CDDB_SubmitSetURL       := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetURL));
        CDDB_SubmitSetOrigArtist:= GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetOrigArtist));
        CDDB_SubmitPerform      := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitPerform));
        CDDB_SubmitSetParams    := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitSetParams));
        CDDB_SubmitGetParams    := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySubmitGetParams));
        CDDB_SetMultipleMatchCategory := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibrarySetMultipleMatchCategory));
        CDDB_GetError           := GetProcAddress(CDDBLibraryDLLHandle, PChar(NAME_CDDBLibraryGetError));

    end;

    if (@CDDB_Create = nil)
    OR (@CDDB_Free = nil)
    OR (@CDDB_SetParams = nil)
    OR (@CDDB_GetParams = nil)
    OR (@CDDB_Query = nil)
    OR (@CDDB_GetTitle = nil)
    OR (@CDDB_GetTrackCount = nil)
    OR (@CDDB_GetGenre = nil)
    OR (@CDDB_GetArtist = nil)
    OR (@CDDB_GetAlbum = nil)
    OR (@CDDB_GetYear = nil)
    OR (@CDDB_GetComposer = nil)
    OR (@CDDB_GetCopyright = nil)
    OR (@CDDB_GetURL = nil)
    OR (@CDDB_GetOriginalArtist = nil)
    OR (@CDDB_GetRevision = nil)
    OR (@CDDB_SubmitClear = nil)
    OR (@CDDB_SubmitAddTitle = nil)
    OR (@CDDB_SubmitSetGenre = nil)
    OR (@CDDB_SubmitSetArtist = nil)
    OR (@CDDB_SubmitSetAlbum = nil)
    OR (@CDDB_SubmitSetYear = nil)
    OR (@CDDB_SubmitSetComposer = nil)
    OR (@CDDB_SubmitSetCopyright = nil)
    OR (@CDDB_SubmitSetURL = nil)
    OR (@CDDB_SubmitSetOrigArtist = nil)
    OR (@CDDB_SubmitPerform = nil)
    OR (@CDDB_SubmitSetParams = nil)
    OR (@CDDB_SubmitGetParams = nil)
    OR (@CDDB_SetMultipleMatchCategory = nil)
    OR (@CDDB_GetError = nil)
        then Result := False;

    if Result
        then CDDBLibraryDLLoaded := True;
end;

function FreeCDDBLibrary: Boolean;
begin
    Result := False;
    if CDDBLibraryDLLHandle <> 0 then begin
        Result := FreeLibrary(CDDBLibraryDLLHandle);
        if Result
            then CDDBLibraryDLLoaded := False;
    end;
end;

end.
